//--------------------------------
// PCF8583 driver
// Author: Sadegh Mohammadi
// Date: 1391/05/05
//--------------------------------

#include "stm32f10x.h"
#include "I2C.h"
#include "USART_init_.h"
#include "lcd4bit.h"

 unsigned char mTime_tmp_[4],B2D[2],Time_H_M_S[3];

//--------------------------------------------------------------
void BCD2Deci_(unsigned int B2D_tmp)
{
	B2D[0]= (B2D_tmp & 0xF0)>>4;
	B2D[1]= (B2D_tmp & 0x0F);
}

//----------------------------------------------
void Start_counter_(void)
{
  Write_Register_I2C(0x00,0x04);
}
//----------------------------------------------
void Stop_counter_(void)
{
  Write_Register_I2C(0x00,0x00);	
}
//-----------------------------------------------
void Set_Timer_Alarm_(void)
{
  Write_Register_I2C(0x08,0x89);	
	Write_Register_I2C(0x07,0x00);
}
//-----------------------------------------------
void Read_Time_I2C(uint8_t EN_alarm)
{
	
	uint8_t  cmd_=0x01;
	
	if(EN_alarm==1){
	   cmd_=0x09;
	}
	
	//I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0xA0, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale adrese registere marbot be time
	I2C_SendData(I2C2,cmd_);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	
		
	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable reading operation */		
	I2C_Send7bitAddress(I2C2, 0xA1, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED )){}

	// daryafte data marbot be time
	while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}	
	mTime_tmp_[3] = I2C_ReceiveData(I2C2);  //reading Houndreds
	
  while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}			
	mTime_tmp_[2] = I2C_ReceiveData(I2C2);  //reading Seconds
		
  while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}
  mTime_tmp_[1] = I2C_ReceiveData(I2C2);  //reading Minuts
	
	I2C_AcknowledgeConfig(I2C2,DISABLE);
	while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}		
	mTime_tmp_[0] = I2C_ReceiveData(I2C2);  //reading Hours	
	
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
	
	I2C_AcknowledgeConfig(I2C2,ENABLE);
  ChTostr(mTime_tmp_[2],2);
}

//-----------------------------------------------
void Read_Time_Sec_I2C(uint8_t EN_alarm)
{
	
	uint8_t  cmd_=0x01;
	
	if(EN_alarm==1){
	   cmd_=0x02;  //reading seconds
	}
	
	//I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0xA0, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale adrese registere marbot be time
	I2C_SendData(I2C2,cmd_);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	
		
	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable reading operation */		
	I2C_Send7bitAddress(I2C2, 0xA1, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED )){}

	I2C_AcknowledgeConfig(I2C2,DISABLE);
	while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}		
	Time_H_M_S[2] = I2C_ReceiveData(I2C2);  //reading Hours	
	
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
	
	I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	//BCD2Deci_(mTime_tmp_[0]);
	//ChTostr(B2D[0],1);
	//ChTostr(B2D[1],1);
	printf_me("%x\n\r",6,Time_H_M_S[2]);
}
//-------------------------------------------------------------
void Read_Time_Min_I2C(uint8_t EN_alarm)
{
	
	uint8_t  cmd_=0x01;
	
	if(EN_alarm==1){
	   cmd_=0x03;  //reading minutes
	}
	
	//I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0xA0, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale adrese registere marbot be time
	I2C_SendData(I2C2,cmd_);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	
		
	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable reading operation */		
	I2C_Send7bitAddress(I2C2, 0xA1, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED )){}

	I2C_AcknowledgeConfig(I2C2,DISABLE);
	while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}		
	Time_H_M_S[1] = I2C_ReceiveData(I2C2);  //reading Hours	
	
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
	
	I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	//BCD2Deci_(mTime_tmp_[0]);
	//ChTostr(B2D[0],1);
	//ChTostr(B2D[1],1);
	printf_me("%x\n\r",6,Time_H_M_S[1]);
}
//------------------------------------------------------------
void Read_Time_Hour_I2C(uint8_t EN_alarm)
{
	
	uint8_t  cmd_=0x01;
	
	if(EN_alarm==1){
	   cmd_=0x04;  //reading hours
	}
	
	//I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0xA0, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale adrese registere marbot be time
	I2C_SendData(I2C2,cmd_);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	
		
	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable reading operation */		
	I2C_Send7bitAddress(I2C2, 0xA1, I2C_Direction_Receiver);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_RECEIVER_MODE_SELECTED )){}

	I2C_AcknowledgeConfig(I2C2,DISABLE);
	while ( !I2C_GetFlagStatus(I2C2,I2C_FLAG_RXNE) ){}		
	Time_H_M_S[0] = I2C_ReceiveData(I2C2);  //reading Hours	
	
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
	
	I2C_AcknowledgeConfig(I2C2,ENABLE);
	
	//BCD2Deci_(mTime_tmp_[0]);
	//ChTostr(B2D[0],1);
	//ChTostr(B2D[1],1);
	printf_me("%x\n\r",6,Time_H_M_S[0]);
}
//------------------------------------------------------------
void Setting_time(unsigned char *Time_tmp,uint8_t EN_alarm)
{
	
	uint8_t  cmd_=0x01;
	
	if(EN_alarm==1){
	   cmd_=0x09;
	}
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0xA0, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale farmane registere marbot be time
	I2C_SendData(I2C2,cmd_);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_SendData(I2C2,Time_tmp[3]); // sending hundreds
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}	

	I2C_SendData(I2C2,Time_tmp[2]); // sending seconds
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}		
		
	I2C_SendData(I2C2,Time_tmp[1]); // sending minutes
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}	
		
	I2C_SendData(I2C2,Time_tmp[0]); // sending hours
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}			
		
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
}
//--------------------------------------------------------------
void Setting_date(unsigned char *Date_tmp,uint8_t EN_alarm)
{
	
	uint8_t  cmd_=0x05;
	
	if(EN_alarm==1){
	   cmd_=0x0d;
	}
	
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BUSY)) {}
		
	I2C_GenerateSTART(I2C2, ENABLE);
	while (I2C_GetFlagStatus(I2C2,I2C_FLAG_SB) == RESET){}	

	// ersale adrese marbot be PCF8583
	/* Transmit the slave address and enable writing operation */
  I2C_Send7bitAddress(I2C2, 0xA0, I2C_Direction_Transmitter);
	while (!I2C_CheckEvent(I2C2, I2C_EVENT_MASTER_TRANSMITTER_MODE_SELECTED)){}

	// ersale farmane registere marbot be time
	I2C_SendData(I2C2,cmd_);
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}
	
	I2C_SendData(I2C2,Date_tmp[0]); // sending year
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}	
		
	I2C_SendData(I2C2,Date_tmp[1]); // sending month
  while ((!I2C_GetFlagStatus(I2C2,I2C_FLAG_TXE)) && (!I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF))){}			
		
	//while (I2C_GetFlagStatus(I2C2,I2C_FLAG_BTF)){}
	I2C_GenerateSTOP(I2C2, ENABLE);	
}
//---------------------------------------------------------
void Set_Clock_for_Alarm_(void)
{
	unsigned char Time[4];
	unsigned char Date[2];
	
  Write_Register_I2C(0x08,0xb2);	
	
	Date[0]= 0x0C;  //year
	Date[1]= 0x06;  //month
	Setting_date(Date,0);
	Setting_date(Date,1);
	
	Time[0]= 0x07;  //Hours
	Time[1]= 0x58;  //Minutes
	Time[2]= 0x00;    //Seconds
	Time[3]= 0x00;  //Hundreds
	Setting_time(Time,0);
	
	Time[1]= 0x58;  //Minutes
	Time[2]= 0x59;    //Seconds
	Time[3]= 0x00;  //Hundreds
	Setting_time(Time,1);	
}
//-------------------------------------------
void Show_H_M_S(void)
{
	Read_Time_Hour_I2C(1);
	Read_Time_Min_I2C(1);
	Read_Time_Sec_I2C(1);
}
//-------------------------------------------
void Show_HMS_on_LCD(void)
{
	char TimeLCD[8];
	
	TimeLCD[0] = ( (Time_H_M_S[0] & 0xF0)>>4 )+0x30;
	TimeLCD[1] = (Time_H_M_S[0] & 0x0F)+0x30;
	
	TimeLCD[2] =  ':';
	
	TimeLCD[3] = ( (Time_H_M_S[1] & 0xF0)>>4 )+0x30;
	TimeLCD[4] = (Time_H_M_S[1] & 0x0F)+0x30;
	
	TimeLCD[5] = ':'; //":"

	TimeLCD[6] = ( (Time_H_M_S[2] & 0xF0)>>4 )+0x30;
	TimeLCD[7] = (Time_H_M_S[2] & 0x0F)+0x30;
	
	//TimeLCD = "Sadegh";
	set_cursor(1,1);
	lcd_putsf(TimeLCD);

}
